#include <stdlib.h>

#include <time.h>
#include <sys/timespec.h>
#include <sys/time.h>

#include <fcntl.h> 
#include <sys/types.h> 
#include <unistd.h> 
#include <stdio.h>
#include <machine/cpufunc.h>
#include <iostream>
#include <math.h>
#include <string>

#include <syslog.h>
#include <signal.h>
#include <vector>
#include <fstream>

#include <sys/wait.h>

#define ZERO_VAL 0x00
#define FF_VAL 0xFF 

using namespace std;

class lptmon
{
    protected:
    void gowork();
    void mainloop();
    
//    void operate(int fd);

    static void sighandler(int signum);
    
    public:
    string param;
    void exec();
    void time_dlay(int val);
};

bool isset(string str) {
    int f,f2;
    f = str.find("=",1);
    if (f>-1) {
        f2 = str.find("yes",1);
//	cout << "pos1=" << f << " pos2=" << f2 <<endl;
        if (f2>f) { return true; } else { return false; }
    } else { return false;}
}

int str2int(string str) {
    char* cc;
    int len;
    len = str.size();
    for (int i=0;i!=len;i++) {
      if (isdigit(str[i])) {
      cc[i]=str[i]; }
    }
    len=atoi(cc);
    return len;			       
}
			       	      

int getvalint(string str) {
    int f,f2;
    string s;
    f = str.find("=",1);
    if (f>-1) {
      f2=str.size();
      s=str.substr(f+1,f2-f+1);      
      f2=str2int(s);
      //cout << "I=" <<f<<"\n";
      return f2;      		
    } else { return 0;}
}

string getvalstr(string str) {
    int f,f2;
    string s;
    f = str.find("=",1);
    if (f>-1) {
      f2=str.size();
      s=str.substr(f+1,f2-f-2);      
      while (s.find(" ",0)==0) {
        s.erase(0,1);     
      }
      return s;      		
    } else { return "";}
}


				
bool isper(string str , string pname) {
    int f;
    f = str.find(pname,0);
    if (f>-1) { return true;  } else { return false; }
}
				      

void lptmon::sighandler(int signum)
{
    waitpid(0, 0, WNOHANG);
    }

int openlpt() {
    int fd = open("/dev/io", O_RDWR);
}

int getpins()
{

}

void time_dlay(int val)
{
    time_t t,t1;
    time(&t);
    do
    {
	time(&t1);
    }
    while((t1-t)<val);
}

long gettickcount()
{
    struct timeval tv;
    gettimeofday(&tv,NULL);
    return (tv.tv_sec*1000+tv.tv_usec/1000);
}

int runcmd(string str) {
        char* cc;
        strcpy(cc,str.c_str());
	cout <<"CC="<<cc<<"\n";
        system(cc);  
	
    return 0;
}

void time_delay(int mks) {
    struct timeval tv;
    gettimeofday(&tv,NULL);
    long t1, t2;
    t1 = (tv.tv_sec*1000+tv.tv_usec/1000);
    t2 = t1;
    t1 = t1 + mks;
    while ( t1>t2 ) {
      gettimeofday(&tv,NULL);
      t2 = (tv.tv_sec*1000+tv.tv_usec/1000);
    }
//  cout << "n=" << gettickcount() <<endl;
}

void lptmon::mainloop()
{
    int fd = open("/dev/io", O_RDWR);
    char val = ZERO_VAL; 
    unsigned int x;
    string r;    

    bool p11r,p12r,p13r,p15r,p10r,p10e,p11e,p12e,p13e,p15e,p10s,p11s,p12s,p13s,p15s,pin10,pin11,pin12,pin13,pin15;
    bool p10c,p11c,p12c,p13c,p15c;
    string p10os,p11os,p12os,p13os,p15os;
    string p10oc,p11oc,p12oc,p13oc,p15oc;    
    string p10oe,p11oe,p12oe,p13oe,p15oe;    
    
    int interval_delay=1000;   
	time_t t,t1;
    if (fd==-1) { 
	printf("not open lpt\n"); 
	exit(-1);
    } 
    
    //else outb(0x378,val);
    
    p10s=false;
    p11s=false;    
    p12s=false;    
    p13s=false;    
    p15s=false;    
    
    p10os=""; //     
    p11os="";
    p12os="";
    p13os="";
    p15os="";    

    p10oc=""; //    
    p11oc="";
    p12oc="";
    p13oc="";
    p15oc="";    

    p10oe="";  //    
    p11oe="";
    p12oe="";
    p13oe="";
    p15oe="";

    p11r=false; //revers
    p12r=false;
    p13r=false;
    p10r=false;
    p15r=false;
    
    p11c=false; //  
    p12c=false;
    p13c=false;
    p10c=false;
    p15c=false;

    p11e=false; //enable 
    p12e=false;
    p13e=false;
    p10e=false;
    p15e=false;
    
    //reading settings.......................................
    cout << "reading settings.. \n";
    FILE *ff;
    char ss[255]="";
    string cc;
    int i;

    ff = fopen("/usr/local/etc/lptmon.config","r");
    while (!feof(ff)) {
        fgets(ss,255,ff);
	cc=ss;
	string g;
	g=cc[0];
	if ( (cc.size()>5) &&  ( g!="#" )    ) {
	
	i=cc.find(" "); //    
	if (i>-1) {
	    while ((i!=-1)  ) {
    	        cc.erase(i,1);
		i=cc.find(" ");	
	    }
	} 
	i=cc.find((char)(9)); //    
	if (i>-1) {
	    while ((i!=-1)  ) {
    	        cc.erase(i,1);
		i=cc.find((char)(9));	
	    }
	}
	
        if (isper(cc,"interval_delay")) { interval_delay = getvalint(cc); }

	if (isper(cc,"pin10onstart")) { p10os = getvalstr(ss); }	
	if (isper(cc,"pin11onstart")) { p11os = getvalstr(ss); }		
	if (isper(cc,"pin12onstart")) { p12os = getvalstr(ss); }		
	if (isper(cc,"pin13onstart")) { p13os = getvalstr(ss); }		
	if (isper(cc,"pin15onstart")) { p15os = getvalstr(ss); }	
	
	if (isper(cc,"pin10oncycle")) { p10oc = getvalstr(ss); }			
	if (isper(cc,"pin11oncycle")) { p11oc = getvalstr(ss); }				
	if (isper(cc,"pin12oncycle")) { p12oc = getvalstr(ss); }				
	if (isper(cc,"pin13oncycle")) { p13oc = getvalstr(ss); }				
	if (isper(cc,"pin15oncycle")) { p15oc = getvalstr(ss); }				
	
	if (isper(cc,"pin10onend")) { p10oe = getvalstr(ss); }		
	if (isper(cc,"pin11onend")) { p11oe = getvalstr(ss); }			
	if (isper(cc,"pin12onend")) { p12oe = getvalstr(ss); }			
	if (isper(cc,"pin13onend")) { p13oe = getvalstr(ss); }			
	if (isper(cc,"pin15onend")) { p15oe = getvalstr(ss); }			
	
        if ((isper(cc,"pin10revers")) && (isset(cc))) { p10r=true; }
        if ((isper(cc,"pin11revers")) && (isset(cc))) { p11r=true; }
        if ((isper(cc,"pin12revers")) && (isset(cc))) { p12r=true; }	
        if ((isper(cc,"pin13revers")) && (isset(cc))) { p13r=true; }
        if ((isper(cc,"pin15revers")) && (isset(cc))) { p15r=true; }	
	
        if ((isper(cc,"pin10enable")) && (isset(cc))) { p10e=true; }
        if ((isper(cc,"pin11enable")) && (isset(cc))) { p11e=true; }	
        if ((isper(cc,"pin12enable")) && (isset(cc))) { p12e=true; }	
        if ((isper(cc,"pin13enable")) && (isset(cc))) { p13e=true; }	
        if ((isper(cc,"pin15enable")) && (isset(cc))) { p15e=true; }	

        if ((isper(cc,"pin10cycle")) && (isset(cc))) { p10c=true; }
        if ((isper(cc,"pin11cycle")) && (isset(cc))) { p11c=true; }	
        if ((isper(cc,"pin12cycle")) && (isset(cc))) { p12c=true; }	
        if ((isper(cc,"pin13cycle")) && (isset(cc))) { p13c=true; }	
        if ((isper(cc,"pin15cycle")) && (isset(cc))) { p15c=true; }	

	}
    }
    
//  cout << "p10osddd===["<< p10os << "]" <<endl;
    
    fclose(ff);
		    
    cout << "interval=" << interval_delay <<"\n";
			    
//    if (p10e) { cout << "pin10 enable\n"; }
//    if (p10r) { cout << "pin10 revers\n"; }
    
    //reading settings end...................................
    
    
    cout << "p10os=" << p10os <<"\n";
    
/*    p10s=p10r; //      (  )
    p11s=p11r;
    p12s=p12r;    
    p13s=p13r;
    p15s=p15r;     */
    
    cout << "start working\n";
//    exit(1);

    //  ...................................................................	
    
    while (1) {

    x=inb(0x379);      // printf("%d\n", x);
    r="";
    for (int i = 0; i < sizeof(x) << 3; i++)
	r = ((x & (1 << i))? "1" : "0") + r;

//    cout << "r=" << r << endl;

    pin10 = (r[25]=='0');
    pin11 = (r[24]=='1');
    pin12 = (r[26]=='0');
    pin13 = (r[27]=='0');
    pin15 = (r[28]=='0');    
    
    // pin10
    if ((pin10!=p10r) && (p10e)) {  // pin      
      if (!p10s) {   //           
        p10s=true;
        if (p10os!="") {
	    //cout <<"START="<<p10os<<"\n";
	    strcpy(ss,p10os.c_str());
    	    system(ss);
        }
      } else {    //     
	  //     p10oc
            if (p10oc!="") {
	    //cout <<"CYCLE="<<p10oc<<"\n";	    
	    strcpy(ss,p10oc.c_str());
    	    system(ss);
    	    }
      }   
    } else {
      if (p10s) {
	//     p10oe
        if (p10oe!="") {
	    //cout <<"END="<<p10oe<<"\n";	
            strcpy(ss,p10oe.c_str());
    	    system(ss);
    	    p10s=false;     
	}    
      }
    }
    
    if ((pin11!=p11r) && (p11e)){  // pin      
      if (!p11s) {   //           
        p11s=true;
        if (p11os!="") {
	    //cout <<"START="<<p11os<<"\n";
	    strcpy(ss,p11os.c_str());
    	    system(ss);
        }
      } else {    //     
            if (p11oc!="") {
	    //cout <<"CYCLE="<<p11oc<<"\n";	    
	    strcpy(ss,p11oc.c_str());
    	    system(ss);
    	    }
      }   
    } else {
      if (p11s) {
        if (p11oe!="") {
	    //cout <<"END="<<p11oe<<"\n";	
            strcpy(ss,p11oe.c_str());
    	    system(ss);
    	    p11s=false;     
	}    
	
      }
      
    }


    if ((pin12!=p12r)&&(p12e)) {  // pin      
      if (!p12s) {   //           
        p12s=true;
        if (p12os!="") {
	    //cout <<"START="<<p12os<<"\n";
	    strcpy(ss,p12os.c_str());
    	    system(ss);
        }
      } else {    //     
            if (p12oc!="") {
	    //cout <<"CYCLE="<<p12oc<<"\n";	    
	    strcpy(ss,p12oc.c_str());
    	    system(ss);
    	    }
      }   
    } else {
      if (p12s) {
        if (p12oe!="") {
	    //cout <<"END="<<p12oe<<"\n";	
            strcpy(ss,p12oe.c_str());
    	    system(ss);
    	    p12s=false;     
	}    
      }
    }

    if ((pin13!=p13r)&&(p13e)) {  // pin      
      if (!p13s) {   //           
        p13s=true;
        if (p13os!="") {
	    //cout <<"START="<<p13os<<"\n";
	    strcpy(ss,p13os.c_str());
    	    system(ss);
        }
      } else {    //     
            if (p13oc!="") {
	    //cout <<"CYCLE="<<p13oc<<"\n";	    
	    strcpy(ss,p13oc.c_str());
    	    system(ss);
    	    }
      }   
    } else {
      if (p13s) {
        if (p13oe!="") {
	    //cout <<"END="<<p13oe<<"\n";	
            strcpy(ss,p13oe.c_str());
    	    system(ss);
    	    p13s=false;     
	}    
      }
    }

    if ((pin15!=p15r)&&(p15e)) {  // pin      
      if (!p15s) {   //           
        p15s=true;
        if (p15os!="") {
	    //cout <<"START="<<p15os<<"\n";
	    strcpy(ss,p15os.c_str());
    	    system(ss);
        }
      } else {    //     
            if (p15oc!="") {
	    //cout <<"CYCLE="<<p15oc<<"\n";	    
	    strcpy(ss,p15oc.c_str());
    	    system(ss);
    	    }
      }   
    } else {
      if (p15s) {
        if (p15oe!="") {
	    //cout <<"END="<<p15oe<<"\n";	
            strcpy(ss,p12oe.c_str());
    	    system(ss);
    	    p12s=false;     
	}    
      }
    }


/*    if (pin10==true) cout <<"pin10 on"<<endl;    
    if (pin11==true) cout <<"pin11 on"<<endl;    
    if (pin12==true) cout <<"pin12 on"<<endl;
    if (pin13==true) cout <<"pin13 on"<<endl;
    if (pin15==true) cout <<"pin15 on"<<endl;      */
    

      //time_delay(interval_delay);
      sleep(1);
    }
    
    //  ......................................................................
    
   
   close(fd); 

}


void lptmon::gowork() {

    int pid;
    struct sigaction sa;
	
    cout << "Server start ok ! " << flush;
    pid = fork();
	
    switch(pid)
    {
    case 0:
        setsid();
//        chdir("/");
//        close(0);
//        close(1);
//        close(2);	
        memset(&sa, 0, sizeof(sa));
//	cout << "ddddddd" << endl;
        sa.sa_handler = &sighandler;
        sigaction(SIGCHLD, &sa, 0);
        openlog("lptmon_log", 0, LOG_USER);
//	readset();
        lptmon::mainloop();
        closelog();
        exit(0);
    case -1:
        cout << "fork() error" << endl;
        break;
    default:
        cout << "ok. PID=" << pid << endl;
        break;
    } 
}

void lptmon::exec() {
  gowork();
}

//int main() 
int main(int argc, char* argv[]) { 

//    cout << argv[0]<< endl;
//    cout << argv[1]<< endl;

    lptmon m;    
    m.param=argv[0];
    m.exec();
    
    
   return 0;  
   
}
